#include <iostream>
#ifdef CONST_MEMBER
#undef CONST_MEMBER
#define CONST_MEMBER const
#else
#define CONST_MEMBER
#endif

#ifdef TEMPLATE
#define TEMPLATE_DEF(A1, A2) template <A1, A2>
#define TEMPLATE_USE(X, A1, A2) X<A1, A2>
#else
#define TEMPLATE_DEF(A1, A2)
#define TEMPLATE_USE(X, A1, A2) X
#endif

struct A
{
  static CONST_MEMBER int value;
};

CONST_MEMBER int A::value=2;

struct B
{
  static CONST_MEMBER int value;
};

CONST_MEMBER int B::value = 3;

struct no {};
struct yes { no no_[2]; };

yes test(int(*)());
no test(...);

#define MY_ASSERT(TEST, STRING) \
  std::cout << ((TEST) ? "ok " : "bad ") << STRING << "\n";

TEMPLATE_DEF(class A, class B)
int func(const A&, const B&)
{
  int nonconst =0;
  const int ci = 1;
  auto a = [=] { return ci; };
  MY_ASSERT(sizeof(test(a)) == sizeof(yes) , "const1");
  MY_ASSERT(a() == 1, "const val1");
  auto b = [] { return ci; };
  MY_ASSERT(sizeof(test(b)) == sizeof(yes) , "const2");
  MY_ASSERT(b() == 1, "const val2");
  auto c = [&] { return ci; };
  MY_ASSERT(sizeof(test(c)) == sizeof(yes) , "const3");
  MY_ASSERT(c() == 1, "const val3");
  auto d = [=] { return nonconst; };
  MY_ASSERT(sizeof(test(d)) != sizeof(yes) , "nc1");
  MY_ASSERT(d() == 0, "nc val1");
  auto e = [&] { return nonconst; };
  MY_ASSERT(sizeof(test(e)) != sizeof(yes) , "nc2");
  MY_ASSERT(e() == 0, "nc val2");
  const int expr = A::value;
  auto f = [&] { return expr; };
  MY_ASSERT((sizeof(test(f)) == sizeof(yes)) == std::is_const<decltype(A::value)>::value , "expr1");
  MY_ASSERT(f() == 2, "expr val1");
  auto g = [=] { return expr; };
  MY_ASSERT((sizeof(test(g)) == sizeof(yes)) == std::is_const<decltype(A::value)>::value , "expr2");
  MY_ASSERT(g() == 2, "expr val2");
  const int expr2 = A::value*B::value;
  auto h = [&] { return expr2; };
  MY_ASSERT((sizeof(test(h)) == sizeof(yes)) == std::is_const<decltype(A::value)>::value , "expr3");
  MY_ASSERT(h() == 6, "expr val3");
  auto i = [=] { return expr2; };
  MY_ASSERT((sizeof(test(i)) == sizeof(yes)) == std::is_const<decltype(A::value)>::value , "expr4");
  MY_ASSERT(i() == 6, "expr val4");
}

int main()
{
  TEMPLATE_USE(func, A, B)(A(), B());
}
